﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Drawing;

namespace Trolleybus
{
    /// <summary>
    /// Класс-сущность "Троллейбус"
    /// </summary>
    internal class EntityTrolleybus
    {
        /// <summary>
        /// Скорость
        /// </summary>
        public int Speed { get; private set; }
        /// <summary>
        /// Вес
        /// </summary>
        public float Weight { get; private set; }
        /// <summary>
        /// Цвет кузова
        /// </summary>
        public Color BodyColor { get; private set; }
        /// <summary>
        /// Шаг перемещения троллейбуса
        /// </summary>
        public float Step => Speed * 100 / Weight;
        /// <summary>
        /// Инициализация полей объекта-класса троллейбуса
        /// </summary>
        /// <param name="speed"></param>
        /// <param name="weight"></param>
        /// <param name="bodyColor"></param>
        /// <returns></returns>
        public void Init(int speed, float weight, Color bodyColor)
        {
            Random rnd = new Random();
            Speed = speed <= 0? rnd.Next(50, 150): speed;
            Weight = weight <= 0 ? rnd.Next(40, 70) : weight;
            bodyColor = bodyColor;
        }
    }
}
