﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Trolleybus
{
    public partial class Form1 : Form
    {
        private DrawingTrolleybus _trolleybus;
        public Form1()
        {
            InitializeComponent();
        }
        /// <summary>
        /// Метод прорисовки троллейбуса 
        /// </summary>

        private void Draw()
        {
            Bitmap bmp = new Bitmap(pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _trolleybus?.DrawTransport(gr);
            pictureBoxTrolleybus.Image = bmp;
        }

        /// <summary>
        /// Обработка нажатия "Создать"
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random rnd = new Random();
            _trolleybus = new DrawingTrolleybus();
            _trolleybus.Init(rnd.Next(100, 300), rnd.Next(1000, 2000), Color.FromArgb(rnd.Next(0, 256), rnd.Next(0, 256), rnd.Next(0, 256)));
            //_trolleybus.SetPosition(rnd.Next(10, 100), rnd.Next(10, 100), Location.X, Location.Y, pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            _trolleybus.SetPosition(rnd.Next(10, 100), rnd.Next(pictureBoxTrolleybus.Size.Height - 150, pictureBoxTrolleybus.Size.Height - 100), pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            toolStripStatusLabelSpeed.Text = $"Скорость: {_trolleybus.Trolleybus.Speed}";
            toolStripStatusLabelWeight.Text = $"Вес: {_trolleybus.Trolleybus.Weight}";
            toolStripStatusLabelBodyColor.Text = $"Цвет: {_trolleybus.Trolleybus.BodyColor.Name}";
            Draw();
        }

        private void ButtonMove_Click(object sender, EventArgs e)
        {
            //получаем имя кнопки
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _trolleybus?.MoveTransport(Direction.Up);
                    break;
                case "buttonDown":
                    _trolleybus?.MoveTransport(Direction.Down);
                    break;
                case "buttonLeft":
                    _trolleybus?.MoveTransport(Direction.Left);
                    break;
                case "buttonRight":
                    _trolleybus?.MoveTransport(Direction.Right);
                    break;
            }
            Draw();
        }
        private void PictureBoxTrolleybus_Resize(object sender, EventArgs e)
        {
            _trolleybus?.ChangeBorders(pictureBoxTrolleybus.Width, pictureBoxTrolleybus.Height);
            Draw();
        }
    }
}
